;##################################################################
; DLLAPP
;##################################################################

#Include "IContextMenu.Inc"

Unknown STRUCT
	QueryInterface	DD
	AddRef			DD
	Release			DD
ENDS

IClassFactory STRUCT
	IUnknown		Unknown	<offset ClassFactoryQueryInterface, offset ClassFactoryAddRef, offset ClassFactoryRelease>
	CreateInstance	DD	OFFSET ClassFactoryCreateInstance
	LockServer		DD	OFFSET ClassFactoryLockServer
ENDS

ClassFactoryObject  STRUCT   ; this_
	; interface object
	lpVtbl			DD		0
	; object data
	nRefCount		DD		1
ENDS

IShellExtension STRUCT
	IUnknown	Unknown	<offset ShellExtQueryInterface, offset ShellExtAddRef, offset ShellExtRelease>
	Initialize	DD	offset ShellExtInitialize
ENDS

ShellExtObject STRUCT
	; interface object
	lpVtbl			DD		0
	; object data
	nRefCount		DD		1
ENDS

IContextMenu STRUCT
	IUnknown Unknown <offset ContextMenuQueryInterface, offset ContextMenuAddRef, offset ContextMenuRelease>
	GetCommandString DD offset ContextMenuGetCommandString
	InvokeCommand DD offset ContextMenuInvokeCommand
	QueryContextMenu DD offset ContextMenuQueryContextMenu
ENDS

ContextMenuObject STRUCT
	; interface object
	lpVtbl			DD		offset vtIContextMenu
	; object data
	nRefCount		DD		0
ENDS

CMINVOKECOMMANDINFO STRUCT
	cbSize DD
	fMask DD
	hwnd DD
	lpVerb DD
	lpParameters DD
	lpDirectory DD
	nShow DD
	dwHotKey DD
	hIcon DD
	lpTitle DD
	lpVerbW DD
	lpParametersW DD
	lpDirectoryW DD
	lpTitleW DD
	ptInvoke POINT <>
ENDS

DATA SECTION
	hInstance		DD		0
;	g_cRefThisDll	DD		0
	m_cRef			DD		0
	m_pDataObj		DD		0


	szShellExtensionID		DB	"ShellExtExample",0
	szCLSID					DB	"CLSID",0

	IID_IUnknown			GUID	GUID_IID_IUnknown
	IID_IClassFactory		GUID	GUID_IID_IClassFactory
	IID_IShellExtInit		GUID	GUID_IID_IShellExtInit
	IID_IContextMenu		GUID	GUID_IID_IContextMenu
	CLSID_ShellExtension	GUID	GUID_CLSID_ShellExtension

	// OBJECTS AND VTABLES
	
	vtIClassFactory	IClassFactory <>
	vtShellExtension	IShellExtension <>
	vtIContextMenu	IContextMenu <>
	ObjClassFactory	ClassFactoryObject <offset vtIClassFactory , 0>
	ObjShellExtension	ShellExtObject <0,0>
	ObjContextMenu ContextMenuObject <offset vtIContextMenu, 0>

;##################################################################

CODE SECTION

DllEntryPoint	FRAME hInst, reason, reserved1

	mov eax,[reason]
	.DLLPROCESSATTACH
	cmp eax,DLL_PROCESS_ATTACH
	JNE >.DLLPROCESSDETACH
		mov eax,[hInst]
		mov [hInstance], eax
		JMP >.LOAD
	
	.DLLPROCESSDETACH
	cmp eax,DLL_PROCESS_DETACH
	JNE >.DLLTHREADATTACH
		JMP >.LOAD
	
	.DLLTHREADATTACH
	cmp eax,DLL_THREAD_ATTACH
	JNE >.DLLTHREADDETACH
		JMP >.LOAD
	
	.DLLTHREADDETACH
	cmp eax,DLL_THREAD_DETACH
	JNE >.NOLOAD
		JMP >.LOAD
	
	.NOLOAD
		; The reson was not understood
		; Rather than take a chance we will refuse to load
		xor eax, eax
		ret
	
	.LOAD
		xor eax, eax
		inc eax

	ret
ENDF

//---------------------------------------------------------------------------
// Minimum Export Requirements
//---------------------------------------------------------------------------

DllCanUnloadNow:
    mov eax, S_FALSE
	cmp D[ObjClassFactory.nRefCount],0
	jne >
	mov eax, S_OK
	:
	ret

DllGetClassObject FRAME this, rclsid, riid, ppvOut
    mov D[ppvOut], NULL

	invoke IsEqualGUID, [rclsid], offset CLSID_ShellExtension
	test eax,eax
	jz >
        invoke ClassFactoryQueryInterface,offset vtIClassFactory,[riid],[ppvOut]
        ret
    :
    mov eax, CLASS_E_CLASSNOTAVAILABLE
    ret
ENDF

DllRegisterServer FRAME
	uses ebx
	LOCAL hKey	:D
	LOCAL hSubKey :D
	LOCAL szIID[128]:B
	LOCAL szIIDW[256]:B
	LOCAL szCLSID[MAX_PATH]:B
	LOCAL szDllPath[MAX_PATH]:B

	invoke StringFromGUID2,offset CLSID_ShellExtension,offset szIIDW,128
	invoke WideCharToMultiByte, CP_ACP, 0, offset szIIDW, -1, offset szIID, MAX_PATH, NULL, NULL
	dec eax
	mov ebx,eax

	// Build our CLSID main key
	invoke lstrcpy,offset szCLSID,"CLSID\"
	invoke lstrcat,offset szCLSID,offset szIID

	invoke RegCreateKey,HKEY_CLASSES_ROOT,offset szCLSID,offset hKey
	cmp eax, ERROR_SUCCESS
	jne >>.notregistered
	invoke RegSetValueEx,[hKey],"",0,REG_SZ,"IContextMenu example",20
	invoke RegCloseKey,[hKey]

	invoke lstrcat,offset szCLSID,"\InprocServer32"

	//Open the main key
	invoke RegCreateKey,HKEY_CLASSES_ROOT,offset szCLSID,offset hKey
	cmp eax, ERROR_SUCCESS
	jne >>.notregistered
	invoke GetModuleFileName,[hInstance],addr szDllPath,MAX_PATH
	invoke RegSetValue,[hKey],0,REG_SZ,addr szDllPath,eax
	invoke RegSetValueEx,[hKey],"ThreadingModel",0,REG_SZ,"Apartment",9
	invoke RegCloseKey,[hKey]

	invoke RegCreateKey,HKEY_CLASSES_ROOT,"dllfile\shellex\ContextMenuHandlers\IContextMenu",offset hKey
	cmp eax, ERROR_SUCCESS
	jne >>.notregistered
	invoke RegSetValue,[hKey],0,REG_SZ,addr szIID,ebx
	invoke RegCloseKey,[hKey]

	invoke RegCreateKey,HKEY_CLASSES_ROOT,"exefile\shellex\ContextMenuHandlers\IContextMenu",offset hKey
	cmp eax, ERROR_SUCCESS
	jne >.notregistered
	invoke RegSetValue,[hKey],0,REG_SZ,addr szIID,ebx
	invoke RegCloseKey,[hKey]

	invoke SHChangeNotify,SHCNE_ASSOCCHANGED,SHCNF_IDLIST,0,0

	mov eax,S_OK
	ret

	.notregistered
	mov eax, -1 
	ret
ENDF

DllUnregisterServer FRAME
	LOCAL hKey	:D
	LOCAL hSubKey :D
	LOCAL szIID[128]:B
	LOCAL szIIDW[256]:B
	LOCAL szCLSID[MAX_PATH]:B
	LOCAL szDllPath[MAX_PATH]:B

	invoke RegOpenKey,HKEY_CLASSES_ROOT,"exefile\shellex\ContextMenuHandlers",offset hKey
	cmp eax, ERROR_SUCCESS
	jne >
	invoke RegDeleteKey,[hKey],"IContextMenu"
	invoke RegCloseKey,[hKey]
	:

	invoke RegOpenKey,HKEY_CLASSES_ROOT,"dllfile\shellex\ContextMenuHandlers",offset hKey
	cmp eax, ERROR_SUCCESS
	jne >
	invoke RegDeleteKey,[hKey],"IContextMenu"
	invoke RegCloseKey,[hKey]

	:
	invoke StringFromGUID2,offset CLSID_ShellExtension,offset szIIDW,128
	invoke WideCharToMultiByte, CP_ACP, 0, offset szIIDW, -1, offset szIID, MAX_PATH, NULL, NULL

	// Build our CLSID main key
	invoke lstrcpy,offset szCLSID,"CLSID\"
	invoke lstrcat,offset szCLSID,offset szIID

	invoke RegOpenKey,HKEY_CLASSES_ROOT,offset szCLSID,offset hKey
	cmp eax, ERROR_SUCCESS
	jne >
	invoke RegDeleteKey,[hKey],"InprocServer32"
	invoke RegCloseKey,[hKey]
	:

	invoke StringFromGUID2,offset CLSID_ShellExtension,offset szIIDW,128
	invoke WideCharToMultiByte, CP_ACP, 0, offset szIIDW, -1, offset szIID, MAX_PATH, NULL, NULL
	invoke RegOpenKey,HKEY_CLASSES_ROOT,"CLSID",offset hKey
	cmp eax, ERROR_SUCCESS
	jne >
	invoke RegDeleteKey,[hKey],offset szIID
	invoke RegCloseKey,[hKey]
	:

	invoke SHChangeNotify,SHCNE_ASSOCCHANGED,SHCNF_IDLIST,0,0

    xor eax, eax    ; mov eax, S_OK
    ret
ENDF

/*
****************************************************************************************
IClassFactory Handler
****************************************************************************************
*/

ClassFactoryQueryInterface FRAME this,riid, ppv

	mov D[ppv], NULL

    // Any interface on this object is the object pointer
	invoke IsEqualGUID,[riid],[IID_IUnknown]
	push eax
	invoke IsEqualGUID,[riid],[IID_IClassFactory]
	pop ecx
	or eax,ecx
	jz >.NOINTERFACE
		mov eax,[this]
		mov [ppv],eax
		invoke ClassFactoryAddRef, eax
		xor eax,eax
        ret
	.NOINTERFACE
	mov eax,E_NOINTERFACE
    ret
ENDF

ClassFactoryAddRef FRAME this
    inc D[ObjClassFactory.nRefCount]
    mov eax,[ObjClassFactory.nRefCount]
	ret
ENDF

ClassFactoryRelease FRAME this
	dec D[ObjClassFactory.nRefCount]
	jz >
        mov eax,D[ObjClassFactory.nRefCount]
	:
	ret
ENDF

ClassFactoryCreateInstance FRAME this, pUnkOuter, riid, ppvObj

    mov D[ppvObj], NULL

    // Shell extensions typically don't support aggregation (inheritance)

	cmp D[pUnkOuter],0
	je >
        mov eax, CLASS_E_NOAGGREGATION
		ret
	:
    // Create the main shell extension object.  The shell will then call
    // QueryInterface with IID_IShellExtInit--this is how shell extensions are
    // initialized.

	invoke CreateShellExtObject
	test eax,eax
	jnz >
		mov eax,E_OUTOFMEMORY
		ret
	:

	invoke [eax+IShellExtension.IUnknown.QueryInterface],eax,[riid],[ppvObj]
    ret
ENDF

CreateShellExtObject FRAME
    LOCAL   pNewObject:D

    ; make a new object
    invoke  CoTaskMemAlloc, sizeof ShellExtObject
    mov [pNewObject], eax
	test eax,eax
	jz >
        ; we got our memory
        ; initialize the new object
        mov edx, [pNewObject]
        mov D[edx+ShellExtObject.lpVtbl], OFFSET vtShellExtension
        mov D[edx+ShellExtObject.nRefCount], 1
    :
    mov eax, [pNewObject]         ; restore our memory pointer
    ret
ENDF

ClassFactoryLockServer FRAME this, fLock
    xor eax,eax
    ret
ENDF

/*
****************************************************************************************
IShellExtension Handler
****************************************************************************************
*/

ShellExtInitialize FRAME this, pIDFolder, pDataObj, hRegKey
    // Initialize can be called more than once
	mov eax,[m_pDataObj]
	test eax,eax
	jz >
		invoke [eax+IShellExtension.IUnknown.Release],eax
	:

	mov eax,[pDataObj]
	test eax,eax
	jz >
		mov [m_pDataObj],eax
		invoke [eax+IShellExtension.IUnknown.AddRef], eax
	:
	invoke MessageBox,0,"ShellExtInitialize",0,0
	mov eax, NOERROR
	ret
ENDF

ShellExtAddRef FRAME this
	mov eax,[this]
	inc D[eax+ShellExtObject.nRefCount]
	mov eax,[eax+ShellExtObject.nRefCount]
	ret
ENDF

ShellExtRelease FRAME this
	mov eax,[this]
	dec D[eax+ShellExtObject.nRefCount]
	jz >
		mov eax,[eax+ShellExtObject.nRefCount]
	:
	ret
ENDF

ShellExtQueryInterface FRAME  this, pUnkOuter, riid, ppv

	mov eax,[ppv]
    mov D[eax], 0

	invoke IsEqualGUID, [riid], offset IID_IShellExtInit
	push eax
	invoke IsEqualGUID, [riid], offset IID_IUnknown
	pop ecx
	or eax,ecx
	jz >
		mov eax, [this]
		mov edx, [ppv]
		mov [edx],eax
		mov eax, NOERROR
		ret
	:
	invoke IsEqualGUID, [riid], offset IID_IContextMenu
	test eax,eax
	jz >
		mov eax, offset ObjContextMenu ;[this]
		mov edx, [ppv]
		mov [edx],eax
		mov eax, NOERROR
		ret
	:
	mov eax,E_NOINTERFACE
	ret
ENDF

/*
****************************************************************************************
IContextMenu Handler
****************************************************************************************
*/

ContextMenuQueryInterface FRAME  this, pUnkOuter, riid, ppv

	mov eax,[ppv]
    mov D[eax], 0

	invoke IsEqualGUID, [riid], offset IID_IContextMenu
	push eax
	invoke IsEqualGUID, [riid], offset IID_IUnknown
	pop ecx
	or eax,ecx
	jz >
		mov eax, [this]
		mov edx, [ppv]
		mov [edx],eax
		mov eax, NOERROR
		ret
	:
	mov eax,E_NOINTERFACE
	ret
ENDF

ContextMenuAddRef FRAME this
	mov eax,[this]
	inc D[eax+ContextMenuObject.nRefCount]
	mov eax,[eax+ContextMenuObject.nRefCount]
	ret
ENDF

ContextMenuRelease FRAME this
	mov eax,[this]
	dec D[eax+ContextMenuObject.nRefCount]
	jz >
		mov eax,[eax+ContextMenuObject.nRefCount]
	:
	ret
ENDF

ContextMenuInvokeCommand FRAME this,lpcmi
	uses ebx
    //If HIWORD(lpcmi->lpVerb) then we have been called programmatically
    //and lpVerb is a command that should be invoked.  Otherwise, the shell
    //has called us, and LOWORD(lpcmi->lpVerb) is the menu ID the user has
    //selected.  Actually, it's (menu ID - idCmdFirst) from QueryContextMenu().
   
    mov ebx, [lpcmi]
    mov edx, [ebx+CMINVOKECOMMANDINFO.lpVerb]
    shr edx,16
    test edx,edx
    jnz >.isverb
    	; this is a menu ID so execute the right sub
    	cmp D[ebx+CMINVOKECOMMANDINFO.lpVerb], 0
    	jne >
    		invoke DoMenu, [ebx+CMINVOKECOMMANDINFO.hwnd], [ebx+CMINVOKECOMMANDINFO.lpDirectory], \
    			[ebx+CMINVOKECOMMANDINFO.lpVerb], [ebx+CMINVOKECOMMANDINFO.lpParameters], [ebx+CMINVOKECOMMANDINFO.nShow]
			ret
		:
		; The next menu item would go here
	.isverb
	mov eax, E_INVALIDARG
	ret
ENDF

ContextMenuGetCommandString FRAME this,idCmd,uFlags,reserved,pszName,cchMax
	
	cmp D[idCmd],0
	jne >
		invoke lstrcpyn, [pszName], "New menu item number 1", [cchMax]
	:
	mov eax, NOERROR
	RET
ENDF

ContextMenuQueryContextMenu FRAME this, hMenu, indexMenu, idCmdFirst, idCmdLast, uFlags
	uses ebx
	LOCAL idCmd	:D
	LOCAL bAppendItems :D
	
	mov ebx,[indexMenu]
	mov D[bAppendItems],TRUE
	mov eax,[idCmdFirst]
	mov [idCmd],eax

	mov eax, [uFlags]
	and eax, CMF_DEFAULTONLY
	jnz >
		mov D[bAppendItems], FALSE
	:

	cmp D[bAppendItems], TRUE
	jne >.noappend
		inc ebx
		invoke InsertMenu, [hMenu], ebx, MF_SEPARATOR|MF_BYPOSITION, 0, NULL
		inc ebx
		inc D[idCmd]
        invoke InsertMenu,[hMenu], ebx, MF_STRING|MF_BYPOSITION, [idCmd], "Hello there"
		inc ebx
		invoke InsertMenu, [hMenu], ebx, MF_SEPARATOR|MF_BYPOSITION, 0, NULL
		mov eax,[idCmd]
		sub eax,[idCmdFirst]
		ret

	.noappend
	mov eax, NOERROR
	RET
ENDF

DoMenu FRAME hwnd,lpDirectory,lpVerb,lpParameters,nShow

	invoke MessageBox,0,"This is DoMenu",[lpDirectory],0
	RET
ENDF

